-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}
M.type = "auxilliary"
M.relevantDevice = mainEngine_R, mainEngine_L;
M.throttle_R = 0
M.throttle_L = 0
M.brake_r = 0
M.brake_l = 0
local RL = nil
local RR = nil
local FR = nil
local FL = nil

local min = math.min
local max = math.max
local abs = math.abs

local lift = nil

--local span = nil

local function updateGFX(dt)


  local throttle_R = min(max(electrics.values.throttle_R, 0), 1)
  local throttle_L = min(max(electrics.values.throttle_L, 0), 1)  
  
if electrics.values.gear == "N" then 
	if electrics.values.steering_input > 0.01 then
--	mainEngine_R.motorDirection= 1 ;
--	mainEngine_L.motorDirection= -1 ;
	elseif electrics.values.steering_input < 0.01 then

	else 
	
	end 

else
  
  if electrics.values.throttle < 0.01 then
   electrics.values.throttle_R = (max(-electrics.values.steering_input/3, 0))--* (max(electrics.values.throttle, 0.7))
   electrics.values.throttle_L = (max(electrics.values.steering_input/3, 0))-- * (max(electrics.values.throttle, 0.7))
  else

	electrics.values.throttle_R =  electrics.values.throttle-(max(electrics.values.steering_input*1.5, 0))
	electrics.values.throttle_L = electrics.values.throttle-(max(-electrics.values.steering_input*1.5, 0)) 

  end  
  
 end  
  
  electrics.values.lift_alt = min(max(electrics.values.lift_alt + electrics.values.lift_updown_change * dt * 1, -1), 1)

   if electrics.values.brake < 0.1 then
    electrics.values.brake_r = 100 * (max(electrics.values.steering_input, 0))
   electrics.values.brake_l = 100 * (max(-electrics.values.steering_input, 0))

  else
   electrics.values.brake_r =  1-(max(-electrics.values.steering_input, 0))
   electrics.values.brake_l = 1-(max(electrics.values.steering_input, 0))
  end   
 
 --BRAKE STUFF--
  local brakeR = electrics.values.brake_r
  local brakeL = electrics.values.brake_l
  brake_FR.brakingTorque = 10*(brake_FR.brakingTorque * brakeR)
  brake_RR.brakingTorque = 10*(brake_RR.brakingTorque * brakeR)
  brake_FL.brakingTorque = 10*(brake_FL.brakingTorque * brakeL)
  brake_RL.brakingTorque =10*(brake_RL.brakingTorque * brakeL)


  



 
end

local function init(jbeamData)
  electrics.values.brake_l = 0
  electrics.values.brake_r = 0
  electrics.values.brake_combined = 0
  
  electrics.values.throttle_L = 0
  electrics.values.throttle_R = 0

  electrics.values.lift_alt = 0
  electrics.values.lift_updown_change = 0

--  electrics.values.span = 0
--  electrics.values.span_updown_change = 0  
  for _,wd in pairs(wheels.wheels) do
    if wd.name == "FR" then brake_FR = wd end
    if wd.name == "RR" then brake_RR = wd end
    if wd.name == "FL" then brake_FL = wd end
    if wd.name == "RL" then brake_RL = wd end


  end
end

M.init = init
M.updateGFX = updateGFX
M.update = update

return M